#include <fxlib.h>
#include <string.h>
#include "mcs.h"
#include "menu.h"
#include "special_chars.h"

enum {ERROR, NO_PROGRAM} Popup_type;

void popup(int n)
{
	switch(n) {
		case ERROR:
			PopUpWin(5);
			locate(5, 3); Print("Error");
			locate(6, 5); Print("Press:[MENU]");
			break;
		case NO_PROGRAM:
			PopUpWin(5);
			locate(5, 3); Print("No programs");
			locate(6, 5); Print("Press:[MENU]");
			break;
	}
	while(1) GetKey(&n);
}

void menu(char** offset, int* len)
{
	const struct mcs_dirent *mcs;
	const struct mcs_item *item;
	int key, count, top, row, pos, cur, mb, i, j, length;
	char line[LINE_LEN * 2 + 1], pwd, type, *content;

	mcs = (struct mcs_dirent *)MCS_ENTRY_POINT;
	item = mcs[DIRENT_SYSTEM].addr;
	count = mcs[DIRENT_SYSTEM].count;
	pos = MENU_TOP;
	top = 0;

	if(strncmp((char *)mcs[DIRENT_SYSTEM].name, "system", 8) != 0)
		popup(ERROR);
	if(count == 0)
		popup(NO_PROGRAM);

	while(1) {
		Bdisp_AllClr_VRAM();
		locate(COL_MIN, ROW_MIN);
		Print("Program List");

		for(i = top; i < count && i - top < MENU_SIZE; i++) {
			pwd = *(char*)((long)item + item[i].offset);
			type = *(char*)((long)item + item[i].offset + 8);
			length = item[i].length + 20;
			content = (char*)((long)item + item[i].offset + 10);
			row = MENU_TOP + (i - top);
			mb = 0;

			memset(line, 0, sizeof(line));
			line[0] = ' ';
			for(j = 0; j < 8; j++) {
				switch((int)(item[i].name[j])) {
					case 0x00: line[mb + j + 1] = ' '; break;
					case 0x89: line[mb + j + 1] = '+'; break;
					case 0x99: line[mb + j + 1] = '-'; break;
					case 0xCE:
						line[mb + j + 1] = CHAR_MB1_THETA;
						line[mb + j + 2] = CHAR_MB2_THETA;
						mb++;
						break;
					default: line[mb + j + 1] = item[i].name[j];
				}
			}

			strncpy(line + mb + 9, "  ", 2);
			line[mb + 11] = (pwd ? '*' : ' ');
			if(type == PROG_TYPE_BASE) {
				line[mb + 12] = CHAR_MB1_PROG_BASE;
				line[mb + 13] = CHAR_MB2_PROG_BASE;
				mb++;
			} else line[mb + 12] = ' ';

			line[mb + 13] = ':';

			strncpy(line + mb + 14, "      ", 6);
			for(j=19 ; j>13 && length ; j--, length/=10)
				line[mb + j] = length%10 + '0';

			if(row == MENU_TOP && top) {
				line[mb + 20] = CHAR_MB1_ARROW_UP;
				line[mb + 21] = CHAR_MB2_ARROW_UP;
				mb++;
			} else if(row == MENU_BTM && i < count - 1) {
				line[mb + 20] = CHAR_MB1_ARROW_DOWN;
				line[mb + 21] = CHAR_MB2_ARROW_DOWN;
				mb++;
			} else line[mb + 20] = ' ';

			locate(COL_MIN, row);
			if(row == pos) PrintRev(line);
			else Print(line);
		}
		cur = top + (pos - MENU_TOP);
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_UP:
				if (cur > 0) {
					if (pos > MENU_TOP)
						pos--;
					else
						top--;
				} else if (count > MENU_SIZE) {
					pos = MENU_BTM;
					top = count - MENU_SIZE;
				} else {
					pos = MENU_TOP + (count - 1);
					top = 0;
				}
				break;
			case KEY_CTRL_DOWN:
				if (cur < count - 1) {
					if (pos < MENU_BTM)
						pos++;
					else
						top++;
				} else {
					pos = MENU_TOP;
					top = 0;
				}
				break;
			case KEY_CTRL_EXE:
				*offset = (char*)((long)item + item[cur].offset + 10);
				*len = item[cur].length-11;
				if(*len > 1) return;
		}
	}
}
